

#include "Blep.h"
#include "aci_cmds.h"
#include "aci_evts.h"
#include "Buggy.h"

sbit LED_CONN at GPIO_PIN34_bit;
sbit LED_DATA at GPIO_PIN18_bit;

extern char writeBuff[32];
extern short readBuff[32];
extern PWM_A_PERIOD;
char CONN_STATE = 0;
char BOND_STATE = 0;
char BREAK_FLAG;
char NEW_EVT, EVT_STATUS, EVT_OPCODE;

extern sfr sbit Blep_RST;
extern sfr sbit Blep_RDY;
extern sfr sbit Blep_REQ;
extern sfr sbit Blep_ACT;

// declarations
void InitTimerB(void);

void Init_MCU() {
   GPIO_Pin_Digital_Output(47);
   GPIO_Pin_Digital_Output(28);
   GPIO_Pin_Digital_Input(1);
   GPIO_Pin_Digital_Input(8);
    //Delay_ms(100);
   Blep_RST = 0;
   SPIM1_Init_Advanced(_SPI_MASTER_CLK_RATIO_64, _SPI_CFG_PHASE_CAPTURE_FALLING | _SPI_CFG_POLARITY_IDLE_LOW | _SPI_CFG_SS_AUTO_DISABLE | _SPI_CFG_FIFO_DISABLE, _SPI_SS_LINE_NONE);
   Blep_REQ = 1;
   asm nop;
   Blep_RST = 1;
   Delay_ms(100);
   Blep_RST = 0;
   Delay_ms(100);
   Blep_RST = 1;
   InitTimerB();

}

void main() {
  GPIO_Pin_Digital_Output(34);
  GPIO_Pin_Digital_Output(18);
  Delay_ms(200);
  Init_MCU();
  Init_Buggy();
  Blep_Setup();
  Delay_ms(100);
  LED_DATA = 0;
  LED_CONN = 0;
  Start_Buggy();
  Blep_Bond(0xB4, 0x20);
  
  while(1){ 
          NEW_EVT = Blep_EventCode();                                           //Wait for new event
          //EVT_STATUS = Blep_EventStatus();                                    //Event Status
          //EVT_OPCODE = Blep_EventOpcode();                                    //Event Opcode
          //LED_CONN = ~ LED_CONN;
          switch(NEW_EVT) {
                case ACI_EVT_INVALID:
                  asm nop;
                  break;
                case ACI_EVT_DEVICE_STARTED:
                  asm nop;
                  break;
                case ACI_EVT_ECHO:
                  asm nop;
                  break;
                case ACI_EVT_HW_ERROR:
                  //DebugInfoEvent returns hardware error debug information
                  //This event is sent from nRF8001 to the external application
                  //controller to provide debug information. In case of firmware
                  //failure this event follows the DeviceStartedEvent.
                  if (CONN_STATE) {
                    delay_ms(20);
                  }else{
                    BREAK_FLAG = 1;
                  }
                  break;
                case ACI_EVT_CMD_RSP:
                  //CommandResponseEvent confirms reception or execution of an ACI command.
                  if (EVT_STATUS > 0x03) { //error
                   BREAK_FLAG = 1;
                   
                  }
                  break;
                case ACI_EVT_CONNECTED:
                  CONN_STATE = 1;
                  LED_CONN = CONN_STATE;
                  break;
                case ACI_EVT_DISCONNECTED:
                  CONN_STATE = 0;
                  LED_CONN = CONN_STATE;
                  LED_DATA = 0;
                  BOND_STATE = 0,
                  Blep_Bond(0xB4, 0x20);
                  break;
                case ACI_EVT_BOND_STATUS:
                   BOND_STATE = 1;
                   break;
                case ACI_EVT_PIPE_STATUS:
                   asm nop;
                   break;
                case ACI_EVT_TIMING:
                   asm nop;
                   break;
                case ACI_EVT_DATA_CREDIT:
                   asm nop;
                   break;
                case ACI_EVT_DATA_ACK:
                   asm nop;
                   break;
                case ACI_EVT_DATA_RECEIVED:
                   LED_DATA = ~LED_DATA;
                   OnDataReceived();
                   break;
                case ACI_EVT_PIPE_ERROR:
                   asm nop;
                   break;
                case ACI_EVT_DISPLAY_PASSKEY:
                   asm nop;
                   break;
                case ACI_EVT_KEY_REQUEST:
                   asm nop;
                   break;
          }
  }
}